SystemOrganization addCategory: #'Glamour-Morphic-Pager'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Announcement'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Glamour'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Model'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Morphic'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Tests'!

EventHandlerPlus subclass: #GLMEventHandler
	instanceVariableNames: 'announcer selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMEventHandler class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 15:55'!
fromHandler: aHandler
	|h|
	
	h := GLMEventHandler new.
	h copySameFrom: aHandler.
	^ h.! !

!GLMEventHandler methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 15:37'!
announcer
	"for subscriptions use:

	subscribeOn: selector send: recipientSelector to: recipient."
	
	^ announcer ifNil: [ announcer := Announcer new ].! !

!GLMEventHandler methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 15:29'!
initialize
	super initialize.
	
	selectors := OrderedCollection new.! !

!GLMEventHandler methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:20'!
send: selector to: recipient withEvent: event fromMorph: sourceMorph
	|announcement type|
	
	selector ifNotNil:
		[ super send: selector to: recipient withEvent: event fromMorph: sourceMorph ].
	
	type := event type.
	
	(selectors includes: type) ifTrue: [
		announcement := GLMEventHandlerAnnouncement new.
		announcement
			selector: type;
			recipient: recipient;
			event: event;
			sourceMorph: sourceMorph.
	
		self announcer announce: announcement.
	].
	
	! !

!GLMEventHandler methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:21'!
subscribeOn:eventName send: recipientSelector to: recipient.
	
	(selectors includes: eventName) ifFalse: [
			selectors add: eventName.
	].
	 
	self announcer weak
		on: GLMEventHandlerAnnouncement send: recipientSelector to: recipient.! !

Morph subclass: #GLMPagerBarMorph
	instanceVariableNames: 'buttons scrollBar adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/15/2014 22:45'!
adapter: anAdapter
	
	adapter := anAdapter.
	
	adapter announcer weak
		on: GLMPagePushed send: #onPagePushed: to: self.
		
	adapter announcer weak
		on: GLMPagePoped send: #onPagePoped to: self.
	
	self addButtons.! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
addButtons
	buttons ifNil: [
		buttons := GLMPagerPaneButtonsMorph new.
		buttons adapter: adapter.
		self addMorph: buttons fullFrame: (0@0 extent: 1@1).
	]
	! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:51'!
addScrollBar
	scrollBar ifNil: [
		scrollBar := GLMSlidingScrollMorph new.
		scrollBar adapter: adapter.
		"scrollBar height: self height."
		scrollBar height: adapter circleButtonSize + adapter circleButtonInset.
		
		self addMorph: scrollBar fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 0 @ 0)
					offsets: (0 @ 0 corner: (scrollBar computeWidth) @ (adapter circleButtonSize + adapter circleButtonInset)))
	]! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 14:23'!
bounds: newBounds
	|rect left right   |
	
	rect := newBounds.
	
	left := rect origin.
	right := rect corner.
	
	
	adapter ifNotNil: [
		left := left  - (adapter circleButtonInset / 2 @ 0).
		right := right  + (adapter circleButtonInset / 2 @ 0).
	].
	
	rect := left corner: right.
	
	super bounds: rect! !

!GLMPagerBarMorph methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 14:29'!
initialize
	super initialize.
		
	self 
		color: Color transparent;
		changeProportionalLayout;
		borderWidth: 0.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:09'!
onPagePoped

	buttons onPagePoped.
	scrollBar width: scrollBar computeWidth.! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:08'!
onPagePushed: addedAnnouncement

	buttons onPagePushed: addedAnnouncement.	
	self showOrHideScrollBar.
	scrollBar width: scrollBar computeWidth.
	scrollBar setWidthAfterResizingRight.! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 14:07'!
removeScrollBar
	scrollBar ifNotNil: [
		self removeMorph: scrollBar.
		scrollBar delete.
		scrollBar := nil.
	] ! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:09'!
showOrHideScrollBar
	
	true "adapter pagesCount > adapter numberOfVisiblePages"
		ifTrue: [self addScrollBar ]
		ifFalse: [ self removeScrollBar ].! !

!GLMPagerBarMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 16:47'!
width
	^ buttons width! !

Morph subclass: #GLMPagerMorph
	instanceVariableNames: 'adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerMorph class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:46'!
simpleExample
	|pager adapter|
	adapter := GLMPagerModel new.
	pager :=	GLMPagerMorph new.
	pager adapter: adapter.
	
	pager pushPane: (Morph new color: Color red).
	pager pushPane: (Morph new color: Color green).
	pager pushPane: (Morph new color: Color yellow).
	pager pushPane: (Morph new color: Color blue).
	pager pushPane: (Morph new color: Color pink).
	pager pushPane: (Morph new color: Color red).
	pager pushPane: (Morph new color: Color green).
	pager pushPane: (Morph new color: Color yellow).
	pager pushPane: (Morph new color: Color blue).
	pager pushPane: (Morph new color: Color pink).
	
	pager height: 777.
	pager width: 1337.
	pager openInWindow.
	
	"pager inspect."! !

!GLMPagerMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 17:32'!
adapter
	^ adapter! !

!GLMPagerMorph methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:33'!
adapter: anObject
	adapter := anObject.
	
	self addMorphBack: (GLMPagerScrollMorph new adapter: adapter).
	self addMorphBack: (GLMPagerBarMorph new adapter: adapter).! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 15:51'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."

	^Color transparent! !

!GLMPagerMorph methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 15:48'!
initialize
	super initialize.
	self changeTableLayout;
		changeListDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellPositioning: #center;
		listCentering: #center;
		wrapCentering: #center! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:49'!
popAndReplacePane: aMorph
	adapter popAndReplacePane: aMorph! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:45'!
popPane
	adapter popPane.! !

!GLMPagerMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 16:52'!
pushPane: aMorph
	adapter pushPane: aMorph smooth: true.! !

Morph subclass: #GLMPagerPaneButtonsMorph
	instanceVariableNames: 'adapter indicatorButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:47'!
adapter: anAdapter
	
	adapter := anAdapter.
		
	adapter announcer weak
		on: GLMPageSwitched send: #onPageSwitched to: self.
				
	adapter announcer weak
		on: GLMPagerBoundsChanged send: #onScrollBoundsChanged: to: self.
		
	adapter announcer weak
		on: GLMFocusedPageChanged send: #onFocusedPageChanged to: self.
		
	self updateIndicatorButtons.
	self cellInset: adapter circleButtonInset.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:28'!
buttonCenterByIndex: aNumber
	|left width|
	width := adapter circleButtonSize.
	left := self bounds left.
	^ left + (adapter circleButtonInset / 2) + ( ( aNumber - 1 ) * (adapter circleButtonInset + width)) + (width / 2).! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:00'!
circleButtonClicked: clickedAnnouncement

	"notify adapter that we need to switch page"
	adapter switchPageTo: clickedAnnouncement buttonModel pageIndex! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:28'!
initialize
	super initialize.
		
	self changeTableLayout;
		changeListDirection: #leftToRight;
		cellPositioning: #center;
		listCentering: #center;
		wrapCentering: #center;
		color: Color transparent.
		
	self hResizing: #shrinkWrap.
	
	
	indicatorButtons := OrderedCollection new.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:56'!
markButtonsInside: aBounds
	|index boundsLeft boundsRight firstFound lastFound |	
	
	firstFound := false.
	lastFound := false.
	index := 0.
	
	(adapter pagesCount = 0) ifTrue: [ ^ self ].
	boundsLeft := aBounds x.
	boundsRight := aBounds y.
	
	indicatorButtons do: [ :indicator |
		|buttonCenter|
		index := index + 1.
		buttonCenter := self buttonCenterByIndex: index.
		(buttonCenter > boundsLeft) & (buttonCenter < boundsRight)
			ifTrue: [
				indicator buttonModel check.
				firstFound ifFalse: [
					adapter firstVisiblePageIndex: index.
					firstFound := true.
				]
			]
			ifFalse: [
				"uncheck only if not focused"
				indicator isFocused ifFalse: [ indicator buttonModel uncheck ].
				(firstFound & (lastFound = false)) ifTrue: [
					adapter lastVisiblePageIndex: index - 1.
					lastFound := true.
				]
			].
	].
	lastFound ifFalse: [
		adapter lastVisiblePageIndex: index.
		lastFound := true.
	]
	
		
! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 19:02'!
onFocusedPageChanged

	self updateIndicatorButtonsFocus.
	self updateIndicatorButtons.
! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 21:05'!
onPagePoped
	|button|
	
	button := indicatorButtons last.
	indicatorButtons removeLast.
	button announcer unsubscribe: self.
	
	self removeMorph: button.
	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 19:04'!
onPagePushed: addedAnnouncement
	|button|
	
	button := GLMPagerCircleButtonMorph new.
	indicatorButtons addLast: button.
	
	button buttonModel: (GLMPagerCircleButtonModel new pageIndex: indicatorButtons size).
	button buttonModel on: GLMPagerButtonClicked send: #circleButtonClicked: to: self.
	button height: adapter circleButtonSize.
	button width: adapter circleButtonSize.
	
	self addMorphBack: button.
	
	(indicatorButtons size = 1) ifTrue: [ self updateIndicatorButtonsFocus ].
		
	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 21:04'!
onPageSwitched

	self updateIndicatorButtons.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 21:04'!
onScrollBoundsChanged: boundsChangedAnnouncement

	self markButtonsInside: boundsChangedAnnouncement bounds.
	! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:57'!
updateIndicatorButtons

	"first we uncheck all buttons"
	indicatorButtons do: [ :indicator |
		"uncheck only if not focused"
		indicator isFocused ifFalse: [ indicator buttonModel uncheck ].
	].

	"then check only necessary"
	indicatorButtons from: adapter firstVisiblePageIndex to: adapter lastVisiblePageIndex do: [ :indicator |
		indicator buttonModel check.
	]! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 19:02'!
updateIndicatorButtonsFocus

	"unfocus all"
	indicatorButtons do: [ :each |
		 each setNotFocused.
	].

	(indicatorButtons at: adapter focusedPageIndex) setFocused.! !

!GLMPagerPaneButtonsMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:30'!
width
	|width|
	width := adapter isNotNil
		ifTrue: [ (indicatorButtons size * (adapter circleButtonSize + adapter circleButtonInset )) ]
		ifFalse: [ 0 ].
	^ width! !

Announcement subclass: #GLMEventHandlerAnnouncement
	instanceVariableNames: 'selector recipient event sourceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
event
	^ event! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
event: anObject
	event := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
recipient
	^ recipient! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
recipient: anObject
	recipient := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
selector
	^ selector! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
selector: anObject
	selector := anObject! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
sourceMorph
	^ sourceMorph! !

!GLMEventHandlerAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/19/2014 15:25'!
sourceMorph: anObject
	sourceMorph := anObject! !

Announcement subclass: #GLMFocusedPageChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMNumberOfVisiblePagesChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagePoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagePushed
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph
	^ morph! !

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph: aMorph
	morph := aMorph! !

Announcement subclass: #GLMPageSwitched
	instanceVariableNames: 'smooth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth
	^ smooth! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagerBoundsChanged
	instanceVariableNames: 'bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds
	^ bounds! !

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds: anObject
	bounds := anObject! !

Announcement subclass: #GLMPagerButtonAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonChecked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonClicked
	instanceVariableNames: 'buttonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerButtonClicked methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:25'!
buttonModel
	^ buttonModel! !

!GLMPagerButtonClicked methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:25'!
buttonModel: anObject
	buttonModel := anObject! !

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonDepressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonDeselected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonPressed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonReleased
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonUnChecked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GTPagerButtonSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerButtonFontUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerButtonImageUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerScrolled
	instanceVariableNames: 'value smooth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerScrolled methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:54'!
smooth
	^ smooth! !

!GLMPagerScrolled methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:54'!
smooth: anObject
	smooth := anObject! !

!GLMPagerScrolled methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value
	^ value! !

!GLMPagerScrolled methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value: anObject
	value := anObject! !

BorderedMorph subclass: #GLMPageScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount maxPanes panes currentScrollValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPageScroller methodsFor: 'private' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:35'!
computeScrollValueToPaneByIndex: aNumber
	|value|
	"self halt."
	self totalScrollRange.
	self innerBounds width.
	value := (self leftoverScrollRange = 0)
		ifFalse: [(((panes at: aNumber) position x) / self leftoverScrollRange) "asFloat"]
		ifTrue: [ 0 ].
	^ value.! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 19:49'!
currentScrollValue
	^ currentScrollValue! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
glmAnimateValue: aValue duration: anInteger

	anInteger <= 0
		"if duration is zero, move to the left immediately"
		ifTrue: [ self leftTo: aValue ]
		ifFalse: [
			| startTime start currentValue |
			currentValue := self currentScrollValue.
			startTime := Time millisecondClockValue.
			start := currentValue.
			[	| delta |
				[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
					self scrollValue: (aValue - start) * (delta / anInteger) + start.
					Processor yield
				].
				self scrollValue: aValue
			] fork
		]! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/5/2014 19:49'!
initialize
	super initialize.
	self 
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	
	currentScrollValue := 0.
	paneCount := 0.
	maxPanes := 2.
	panes := OrderedCollection new.! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
initializeScrollbar
	scrollBar := ScrollBar new 
		model: self;
		setValueSelector: #scrollValue:;
		yourself.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset.
! !

!GLMPageScroller methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/5/2014 20:11'!
layoutWidgets

	transform bounds: self innerBounds.! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 13:29'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width) max: 0
! !

!GLMPageScroller methodsFor: 'configuration' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
maxPanes
	^ maxPanes! !

!GLMPageScroller methodsFor: 'configuration' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
maxPanes: anInteger
	maxPanes := anInteger! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
paneCount
	^ paneCount! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
paneHeight
	^ transform bounds height! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/4/2014 10:09'!
popAndReplacePane: aMorph	
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	"remove from collection"
	panes removeLast.
	paneCount := paneCount - 1.	
	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	"adding morph to collection"
	panes addLast: aMorph.
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/4/2014 10:08'!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	"remove from collection"
	panes removeLast.
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/4/2014 10:08'!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	"adding morph to collection"
	panes addLast: aMorph.
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
scrollTo: aValue smooth: aBoolean
 	aBoolean ifTrue: [	self glmAnimateValue: aValue duration: 200]
				ifFalse: [self scrollValue: aValue ].! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
scrollValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.
	currentScrollValue := value.! !

!GLMPageScroller methodsFor: 'panes' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
separator
	^ "BorderedSubpaneDividerMorph new 
		vertical;
		adoptPaneColor: self paneColor;
		yourself"
		
	GLMMorphic emptyMorph! !

!GLMPageScroller methodsFor: 'layout' stamp: 'TudorGirba 4/17/2014 00:04'!
separatorWidth
	^ 10! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 20:08'!
setScrollDeltas
	self scrollTo: self currentScrollValue smooth: false.! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/5/2014 20:18'!
setScrollDeltasSmooth
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPageScroller methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPageScroller methodsFor: 'layout' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPageScroller methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/5/2014 20:14'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self setScrollDeltasSmooth.! !

!GLMPageScroller methodsFor: 'updating' stamp: 'AliakseiSyrel 4/3/2014 21:21'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

GLMPageScroller subclass: #GLMPagerScrollMorph
	instanceVariableNames: 'pane adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:35'!
adapter: anAdapter
	
	adapter := anAdapter.
	
	adapter announcer weak
		on: GLMPagePushed send: #onPagePushed: to: self.
	
	adapter announcer weak
		on: GLMPagePoped send: #onPagePoped to: self.
		
	adapter announcer weak
		on: GLMPageSwitched send: #onPageSwitched: to: self.
				
	adapter announcer weak
		on: GLMPagerScrolled send: #onScrolled: to: self.
		
	adapter announcer weak 
		on: GLMNumberOfVisiblePagesChanged send: #onPagesNumberChanged to: self.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:53'!
focusChanged: anEvent

	adapter focusedPageIndex: (self pageOf: anEvent sourceMorph).! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 15:19'!
initialize
	super initialize.
	
	self color: Color transparent.
	
! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:48'!
listenAnnouncementsOf: aMorph
	aMorph ifNotNil: [
		
		self modifyHandler: aMorph.
	
		aMorph submorphs do: [ :each |
			self listenAnnouncementsOf: each.
		].
	].
	
	! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:44'!
modifyHandler: aMorph
	| handler |
	
	handler := aMorph eventHandler ifNotNil: [ 
		GLMEventHandler fromHandler: aMorph eventHandler.
	] ifNil: [ 
		GLMEventHandler new.
	].
	
	aMorph eventHandler: handler.	
	handler subscribeOn: #mouseDown send: #focusChanged: to: self.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:35'!
onPagePoped
	self popPane.
	! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 14:23'!
onPagePushed: pushedAnnouncement
	|morph|
	morph := pushedAnnouncement morph.
	
	"added new page to the end of pane"
	self pushPane: morph.
	
	self listenAnnouncementsOf: morph.
! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 17:49'!
onPageSwitched: switchedAnnouncement
	adapter scrollTo: (self computeScrollValueToPaneByIndex: adapter firstVisiblePageIndex) smooth: switchedAnnouncement smooth.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 16:14'!
onPagesNumberChanged

	self maxPanes: adapter numberOfVisiblePages.
	self basicUpdateSizing.
	self layoutPanes.
	self setScrollDeltas.! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 12:45'!
onScrolled: scrolledAnnouncement

	"directly scrolls to value"
	self scrollTo: scrolledAnnouncement value smooth: scrolledAnnouncement smooth.
	! !

!GLMPagerScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 16:55'!
pageOf: aSubMorph
	|parent|
	
	parent := aSubMorph.
	
	[parent isNotNil & (panes includes: parent) not ] whileTrue: [
		parent := parent owner.
	].

	^ panes indexOf: parent.! !

!GLMMorphicRenderer methodsFor: '*Glamour-Morphic-Pager-Glamour' stamp: 'TudorGirba 4/16/2014 21:55'!
renderPager: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicPagerFinderRenderer render: aBrowser from: self]
		ifFalse: []! !

!GLMCompositePresentation methodsFor: '*Glamour-Morphic-Pager-Glamour' stamp: 'TudorGirba 4/16/2014 21:56'!
pager
	^ self custom: GLMPager new! !

SimpleButtonMorph subclass: #GLMButton
	instanceVariableNames: 'fontModel buttonModel imageModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

GLMButton class
	instanceVariableNames: 'model'!

!GLMButton commentStamp: 'AliakseiSyrel 3/27/2014 22:18' prior: 0!
|form newForm|

form := ImageReadWriter formFromFileNamed: '9patch.png'.
newForm := Patch9Form scalePatch9Form: form size:  100@100.
(ImageMorph withForm: newForm) openInWindow.!

GLMButton class
	instanceVariableNames: 'model'!

!GLMButton class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
with: aModel
	^ ABCButtonView new model: aModel! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
buttonModel
	^ buttonModel! !

!GLMButton methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:34'!
buttonModel: aModel
	buttonModel := aModel.
	
	buttonModel announcer weak
		on: GLMPagerButtonPressed send: #onPressed to: self.
	
	buttonModel announcer weak
		on: GLMPagerButtonDepressed send: #onDepressed to: self.
		
	buttonModel announcer weak
		on: GTPagerButtonSelected send: #onSelected to: self.
		
	buttonModel announcer weak
		on: GLMPagerButtonDeselected send: #onDeselected to: self.
		
	buttonModel announcer weak
		on: GLMPagerButtonChecked send: #onChecked to: self.
	
	buttonModel announcer weak
		on: GLMPagerButtonUnChecked send: #onUnChecked to: self.! !

!GLMButton methodsFor: 'drawing' stamp: 'AliakseiSyrel 4/4/2014 10:53'!
drawOn: aCanvas
	|image|
	image := self image pressed: (self buttonModel isPressed) selected: (self buttonModel isSelected) checked: (self buttonModel isChecked).
	image ifNotNil: [
		aCanvas 
			translucentImage: (self resizeImage: image scale:  (bounds extent / image extent))
			at: bounds origin.
	].
	
	super drawOn: aCanvas.! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
font
	^ fontModel! !

!GLMButton methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:33'!
font: aModel
	fontModel := aModel.
	
	fontModel announcer weak
		on: GLMPagerButtonFontUpdated send: #onFontUpdated to: self.! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
handlesMouseOver: evt
	^ true! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
image
	^ imageModel.! !

!GLMButton methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:33'!
image: anImageModel
	imageModel := anImageModel.
	
	imageModel state announcer weak
		on: GLMPagerButtonImageUpdated send: #onImageUpdated to: self.! !

!GLMButton methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 07:33'!
initialize

	self image: GLMPagerButtonImageModel new.
	self font: GLMPagerButtonFontModel new.
	self buttonModel: GLMPagerButtonModel new.
	
	super initialize.	
	
	self borderWidth: 0.
	
	self color: (Color transparent).! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
label: aString
	super label: aString font: self logicalFont.
	"we need to update label color because label in button is completely recreated =/ "
	label color: self font color.! !

!GLMButton methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
logicalFont
	^ self font logicalFont! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseDown: evt
	self buttonModel press
	! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseEnter: evt
	self buttonModel select! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseLeave: evt
	self buttonModel deselect! !

!GLMButton methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
mouseUp: evt
	self buttonModel depress.
	(bounds containsPoint: evt position)
		ifFalse: [ self buttonModel deselect ] ! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/4/2014 10:48'!
onChecked
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onDepressed
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onDeselected
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onFontUpdated
	self label: self label.! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onImageUpdated
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onPressed
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/2/2014 16:37'!
onSelected
	self changed! !

!GLMButton methodsFor: 'event-handling' stamp: 'AliakseiSyrel 4/4/2014 10:48'!
onUnChecked
	self changed! !

!GLMButton methodsFor: 'drawing' stamp: 'AliakseiSyrel 4/2/2014 18:07'!
resizeImage: anImage scale: aScale
	^ anImage magnify: anImage boundingBox by: aScale smoothing: 2! !

GLMButton subclass: #GLMPagerCircleButtonMorph
	instanceVariableNames: 'checkedIcon checkedFocusedIcon focused'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMPagerCircleButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 19:00'!
initialize
	super initialize.
	
	self label: ''.
	
	checkedIcon := GLMUIThemeExtraIcons glamorousGrayCircle.
	checkedFocusedIcon := GLMUIThemeExtraIcons glamorousRedCircle.
	focused := false.
	
	self image state normal: GLMUIThemeExtraIcons glamorousGrayCircleEmpty.
	self image state selected: checkedIcon.
	self image state checked: checkedIcon.
	! !

!GLMPagerCircleButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:55'!
isFocused
	^ focused! !

!GLMPagerCircleButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 19:00'!
setFocused

	focused ifFalse: [
		self image state checked: checkedFocusedIcon.
		self image state selected: checkedFocusedIcon.
		focused := true.
	]! !

!GLMPagerCircleButtonMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:59'!
setNotFocused

	focused ifTrue: [
		self image state checked: checkedIcon.
		self image state selected: checkedIcon.
		focused := false.
	]! !

GLMButton subclass: #GLMSlidingScrollMorph
	instanceVariableNames: 'startDragX isResizing startResizingWidth adapter resizingZoneWidth isRightResizing isLeftResizing scrollResizingIcon scrollSelectedIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMSlidingScrollMorph methodsFor: 'accessing' stamp: 'TudorGirba 4/16/2014 07:35'!
adapter: anAdapter
	
	adapter := anAdapter.
	
	adapter announcer weak
		on: GLMPagerScrolled send: #onScrolled: to: self.
		
	adapter announcer weak 
		on: GLMNumberOfVisiblePagesChanged send: #onResized to: self.
		
	self width: self computeWidth.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:21'!
computeScrollValue: aNumber
	|minLeft maxLeft value interval|
	
	minLeft := owner bounds left.
	maxLeft := owner bounds right - self width.
	
	aNumber < minLeft ifTrue: [ aNumber := minLeft ].
	aNumber > maxLeft ifTrue: [ aNumber := maxLeft ].
	
	interval := owner width.
	
	self flag: 'TODO: DIRTY HACK'.
	
	value := (interval = self width)
		ifTrue: [ 1.0 ]
		ifFalse: [ (aNumber - minLeft) / (interval - self width) ].
	
	^ value.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:29'!
computeWidth
	|width numberOfVisiblePages|

	
	width := adapter isNotNil
		ifTrue: [
			numberOfVisiblePages := adapter numberOfVisiblePages.
			numberOfVisiblePages > adapter pagesCount
				ifTrue: [ numberOfVisiblePages := adapter pagesCount ].
			(adapter circleButtonInset + adapter circleButtonSize) * numberOfVisiblePages.
		]
		ifFalse: [ 0 ].
		
	^ width.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 14:06'!
delete
	super delete.
	adapter announcer unsubscribe: self.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:42'!
dragResizingLeft: evt
	| leftDelta left right maxLeft|
	
	leftDelta:= (self bounds right - startResizingWidth - evt position x - startDragX).
	
	right := self layoutFrame rightOffset.
	left := right - startResizingWidth - leftDelta.
	maxLeft := right - (adapter circleButtonInset + adapter circleButtonSize).
	
	left := (left max: 0) min: maxLeft.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left)@(owner left + right).
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:45'!
dragResizingRight: evt
	| rightDelta left right minRight maxRight|
	
	rightDelta:= (evt position x - self left - startDragX).
	
	left := self layoutFrame leftOffset.
	right := left + startResizingWidth + rightDelta.
	minRight := left + (adapter circleButtonInset + adapter circleButtonSize).
	maxRight := owner width.
	
	right := (right max: minRight) min: maxRight.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left)@(owner left + right).
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 12:02'!
dragSliding: evt
	| newLeft value|
	
	newLeft := (evt position x - startDragX).
	value := self computeScrollValue: newLeft.
	
	self notifyScrollBarValue: value.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:21'!
glmAnimateValue: aValue duration: anInteger

	anInteger <= 0
		"if duration is zero, move to the left immediately"
		ifTrue: [ self leftTo: aValue ]
		ifFalse: [
			| startTime start currentValue |
			currentValue := self computeScrollValue: self bounds left.
			startTime := Time millisecondClockValue.
			start := currentValue.
			[	| delta |
				[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
					self leftTo: (aValue - start) * (delta / anInteger) + start.
					Processor yield
				].
				self leftTo: aValue
			] fork
		]! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:39'!
handleMouseOver: anEvent
	super handleMouseOver: anEvent.
		
	isResizing | (self isMouseEventInsideLeftResizingZone: anEvent) | (self isMouseEventInsideRightResizingZone: anEvent)
	ifTrue: [
		self setCursorToResizing: anEvent.
	]
	ifFalse: [
		self setCursorToNormal: anEvent.
	].! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/2/2014 18:40'!
handlesMouseOverDragging: evt
	^ true! !

!GLMSlidingScrollMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/17/2014 12:49'!
initialize
	super initialize.
	
	self label: ''.
	
	resizingZoneWidth := 7.
	isRightResizing := false.
	isLeftResizing := false.
	isResizing := false.
		
	self image state normal: GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.
	scrollResizingIcon := GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.
	scrollSelectedIcon := GLMUIThemeExtraIcons glamorousLargeGrayCircleEmphasized.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 12:43'!
isMouseEventInsideLeftResizingZone: evt
	|resizingRectangle bottom right|
	
	bottom := self bounds bottom.
	right := self bounds left + resizingZoneWidth.
	
	resizingRectangle := self bounds origin corner: right@bottom.
	
	^ resizingRectangle containsPoint: evt position.
	
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 12:12'!
isMouseEventInsideRightResizingZone: evt
	|resizingRectangle top left|
	
	top := self bounds top.
	left := self bounds right - resizingZoneWidth.
	
	resizingRectangle := left@top corner: self bounds corner.
	
	^ resizingRectangle containsPoint: evt position.
	
	! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 12:21'!
leftTo: aValue
	|left|
	
	left := (owner width - self width) * aValue.
		
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: (left + self width)@ self height)
	).
	
	adapter notifyScrollerBoundsChanged: (owner left + left)@(owner left + left + self width).! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/17/2014 12:50'!
mouseDown: evt

	startDragX := (evt position x - self left).
	startResizingWidth := self width.
	
	isRightResizing := self isMouseEventInsideRightResizingZone: evt.
	
	"only one type of resizing is possible"
	isRightResizing ifFalse: [ 
		isLeftResizing := self isMouseEventInsideLeftResizingZone: evt.
	]
	ifTrue: [ isLeftResizing := false ].

	isResizing := (isLeftResizing or: isRightResizing).
	
	"during resizing we can use other image"
	isResizing ifTrue: [ self image state selected: scrollResizingIcon ].
	
	super mouseDown: evt.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:56'!
mouseLeave: evt

	self setCursorToNormal: evt.
	super mouseLeave: evt.! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/6/2014 15:27'!
mouseMove: evt

	isRightResizing
		ifTrue: [ self dragResizingRight: evt ]
		ifFalse: [
			isLeftResizing
				ifTrue: [ self dragResizingLeft: evt ]
				ifFalse: [ self dragSliding: evt ]
		].! !

!GLMSlidingScrollMorph methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 4/17/2014 12:50'!
mouseUp: evt
	super mouseUp: evt.
	
	adapter numberOfVisiblePagesChanged.
	self onResized.
	
	adapter switchPageTo: adapter firstVisiblePageIndex.
	
	isResizing := false.
	
	"setting selected image to default after resizie is complete"
	self image state selected: scrollResizingIcon.
	
	(bounds containsPoint: evt position)
		ifFalse: [ self setCursorToNormal: evt ] ! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 12:54'!
notifyScrollBarValue: aFloat

	adapter scrollTo: aFloat smooth: false.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:57'!
onResized

	isLeftResizing ifTrue: [ self setWidthAfterResizingLeft ].
	isRightResizing ifTrue: [ self setWidthAfterResizingRight ]! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 17:28'!
onScrolled: scrolledAnnouncement

	"directly scrolls to value"
	self scrollTo: scrolledAnnouncement value smooth: scrolledAnnouncement smooth.! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 15:42'!
resizeCursor

	^ Cursor resizeForEdge: #left! !

!GLMSlidingScrollMorph methodsFor: 'drawing' stamp: 'TudorGirba 4/15/2014 22:45'!
resizeImage: anImage scale: aScale

	^ GLMForm scalePatchForm: anImage size: (aScale * anImage extent)! !

!GLMSlidingScrollMorph methodsFor: 'scrolling' stamp: 'AliakseiSyrel 4/5/2014 12:55'!
scrollTo: aValue smooth: aBoolean

	aBoolean
		ifTrue: [ self glmAnimateValue: aValue duration: 200 ]
		ifFalse: [ self leftTo: aValue ] ! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:34'!
setCursorToNormal: evt
		
	evt hand showTemporaryCursor: nil! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/18/2014 11:34'!
setCursorToResizing: evt
	
	evt hand showTemporaryCursor: self resizeCursor! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:55'!
setWidthAfterResizingLeft
	| left right |
	
	right := self layoutFrame rightOffset.
	left := right - self computeWidth.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).! !

!GLMSlidingScrollMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:56'!
setWidthAfterResizingRight
	| left right |
	
	left := self layoutFrame leftOffset.
	right := left + self computeWidth.
	
	self layoutFrame: (
		LayoutFrame 
			fractions: (0 @ 0 corner: 0 @ 0)
			offsets: (left @ 0 corner: right @ self height)
	).! !

GLMFinder subclass: #GLMPager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMPager methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 21:55'!
renderGlamorouslyOn: aRenderer 
	^ aRenderer renderPager: self! !

TestCase subclass: #GLMPagerModelTest
	instanceVariableNames: 'pagerModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Tests'!

!GLMPagerModelTest methodsFor: 'private' stamp: 'AndreiChis 4/15/2014 11:42'!
createSimplePaneMorph

	^ Morph new! !

!GLMPagerModelTest methodsFor: 'running' stamp: 'AliakseiSyrel 4/19/2014 17:46'!
setUp

	pagerModel := GLMPagerModel new.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'TudorGirba 4/15/2014 22:45'!
testEmptyPopPane
	| count |
	
	count := 0.
	pagerModel announcer when: GLMPagePoped do: [ :ann | count := count + 1 ].
	
	pagerModel popPane.
	
	self assert: count equals: 0.
	
	self assert: pagerModel pagesCount equals: 0.
	self assert: pagerModel firstVisiblePageIndex equals: pagerModel defaultFirstVisiblePageIndex.
	self assert: pagerModel lastVisiblePageIndex equals: 0.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel defaultNumberOfVisiblePages.
	
	pagerModel popPane.
	pagerModel popPane.
	
	self assert: count equals: 0.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AndreiChis 4/15/2014 11:32'!
testModelInitialization

	self assert: pagerModel pagesCount equals: 0.
	self assert: pagerModel firstVisiblePageIndex equals: pagerModel defaultFirstVisiblePageIndex.
	self assert: pagerModel lastVisiblePageIndex equals: 0.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel defaultNumberOfVisiblePages.! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AndreiChis 4/15/2014 11:42'!
testOnePanePush
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	
	self assert: pagerModel pagesCount equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: pagerModel defaultFirstVisiblePageIndex.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel defaultNumberOfVisiblePages.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'AndreiChis 4/15/2014 12:11'!
testOneReplacePane
	
	pagerModel popAndReplacePane: self createSimplePaneMorph.

	self assert: pagerModel pagesCount equals: 1.
	self assert: pagerModel firstVisiblePageIndex equals: pagerModel defaultFirstVisiblePageIndex.
	self assert: pagerModel lastVisiblePageIndex equals: 1.
	self assert: pagerModel numberOfVisiblePages equals: pagerModel defaultNumberOfVisiblePages.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'TudorGirba 4/15/2014 22:46'!
testOneReplacePaneAnnouncement
	| count currentAnn paneMorph |
	
	count := 0.
	paneMorph := self createSimplePaneMorph.
	pagerModel announcer when: GLMPageSwitched do: [ :ann | count := count + 1. currentAnn := ann ].
	
	pagerModel popAndReplacePane: paneMorph.
	
	self assert: count equals: 1.
	pagerModel popAndReplacePane: self createSimplePaneMorph.
	pagerModel popAndReplacePane: self createSimplePaneMorph.
	
	self assert: count equals: 3.
	! !

!GLMPagerModelTest methodsFor: 'tests' stamp: 'TudorGirba 4/15/2014 22:45'!
testPanePushAnnouncement
	| count currentAnn paneMorph |
	
	count := 0.
	paneMorph := self createSimplePaneMorph.
	pagerModel announcer when: GLMPagePushed do: [ :ann | count := count + 1. currentAnn := ann ].
	
	pagerModel pushPane: paneMorph smooth: false.
	self assert: count equals: 1.
	self assert: currentAnn morph equals: paneMorph.
	
	paneMorph := self createSimplePaneMorph.
	pagerModel pushPane: paneMorph smooth: false.
	self assert: count equals: 2.
	self assert: currentAnn morph equals: paneMorph.
	
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	pagerModel pushPane: self createSimplePaneMorph smooth: false.
	self assert: count equals: 4.! !

Object subclass: #GLMForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 18:15'!
scaleForm: aForm by: aPoint
	^ aForm magnify: aForm boundingBox by: aPoint smoothing: 1! !

!GLMForm class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 14:38'!
scalePatchForm: aForm size: aPoint
	"aPoint - width and height of new form
	
|form|

form := PatchForm scalePatchForm: (ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.p.png') size:800@800.
(ImageMorph withForm: form) openInWindow.

form := ImageReadWriter formFromFileNamed: 'abc_calculator_button_normal.png'.
form := PatchForm scaleForm: form by: (800/(form extent x))@(800/(form extent y)).
(ImageMorph withForm: form) openInWindow.
	
	"
	
	|x0 x1 y0 y1 width height newForm tmpForm color bottomHeight rightWidth newMiddleWidth newMiddleHeight|
	
	color := Color red.
	x0 := x1 := y0 := y1 := 0.
	width := aForm extent x.
	height := aForm extent y.
	
	(0 to: width-1) collect: [ :each |
		(aForm colorAt: each@0) = color ifTrue: [ 
			x0 = 0 ifTrue: [ 
				x0 := each.
			]
		] ifFalse:[
			(x0 > 0 & x1 = 0) ifTrue:[
				x1 := each.
			].
		].
	].

	(0 to: height) collect: [ :each |
		(aForm colorAt: 0@each) = color ifTrue: [ 
			y0 = 0 ifTrue: [ 
				y0 := each.
			]
		] ifFalse:[
			(y0 > 0 & y1 = 0) ifTrue:[
				y1 := each.
			].
		].
	].

	rightWidth := width - x1 -1.
	bottomHeight := height - y1 - 1.
	newMiddleWidth := aPoint x - x0 - rightWidth + 1.
	newMiddleHeight := aPoint y - y0 - bottomHeight + 1.
	
	newForm := Form extent: aPoint depth: aForm depth.
	"left top corner"
	newForm copyBits: (1@1 corner: x0@y0)
		from: aForm at: 0@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"left bottom corner"
	newForm copyBits: (1@y1 corner: x0@(height - 1))
		from: aForm at: 0@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right top corner"
	newForm copyBits: (x1@1 corner: (width-1)@y0)
		from: aForm at: (aPoint x - rightWidth)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	"right bottom corner"
	newForm copyBits: (x1@y1 corner: (width - 1)@(height - 1))
		from: aForm at: (aPoint x - rightWidth)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"top middle block"
	tmpForm := aForm copy: (x0@1 corner: x1@y0).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@0 clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"bottom middle block"
	tmpForm := aForm copy: (x0@y1 corner: x1@height).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@1.
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(aPoint y - bottomHeight) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"left middle block"
	tmpForm := aForm copy: (1@y0 corner: x0@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: 0@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	"right middle block"
	tmpForm := aForm copy: (x1@y0 corner: width@y1).
	tmpForm := self scaleForm: tmpForm by: 1@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (aPoint x - rightWidth)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
		
	"middle block"
	tmpForm := aForm copy: (x0@y0 corner: x1@y1).
	tmpForm := self scaleForm: tmpForm by: ((newMiddleWidth)/(x1-x0))@((newMiddleHeight)/(y1-y0)).
	newForm copyBits: (0@0 corner: (tmpForm extent x)@(tmpForm extent y))
		from: tmpForm at: (x0-1)@(y0-1) clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	
	^ newForm.
	
! !

Object subclass: #GLMPagerButtonFontModel
	instanceVariableNames: 'font color familyName size announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
color
	^ color! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
color: aColor
	color := aColor.
	self updateFont.! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultColor
	^ Color black! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultFamilyName
	^ 'Bitmap DejaVu Sans'! !

!GLMPagerButtonFontModel methodsFor: 'defaults' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
defaultSize
	^ 15! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
familyName
	^ familyName! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
familyName: aString
	familyName := aString.
	self updateFont.! !

!GLMPagerButtonFontModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
initialize
	super initialize.
	
	size := self defaultSize.
	familyName := self defaultFamilyName.
	color := self defaultColor.
	
	self updateFont.
! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
logicalFont
	^ font! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
logicalFont: aFont
	font := aFont.
	familyName := font familyName.
	size := font pointSize.
	self notifyUpdate.! !

!GLMPagerButtonFontModel methodsFor: 'private' stamp: 'TudorGirba 4/16/2014 07:33'!
notifyUpdate
	self announcer announce: GLMPagerButtonFontUpdated new.! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
size
	^ size! !

!GLMPagerButtonFontModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
size: aNumber
	size := aNumber.
	self notifyUpdate.! !

!GLMPagerButtonFontModel methodsFor: 'private' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
updateFont
	font := LogicalFont familyName: self familyName pointSize: self size.
	self notifyUpdate.! !

Object subclass: #GLMPagerButtonImageModel
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonImageModel methodsFor: 'initialization' stamp: 'TudorGirba 4/16/2014 07:33'!
initialize
	super initialize.
	
	state := GLMPagerButtonImageState new.! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal
	^ self pressed: false selected: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed: isPressed
	^ self pressed: isPressed selected: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/4/2014 10:53'!
pressed: isPressed selected: isSelected
	^ self pressed: isPressed selected: isSelected checked: false! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/17/2014 12:39'!
pressed: isPressed selected: isSelected checked: isChecked
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & self state pressed notNil)
		ifTrue: [ ^ self state pressed ].
	
	(((isPressed & self state pressed isNil) | isSelected) & self state selected notNil)
		ifTrue: [ ^ self state selected ].
		
	(isChecked & self state checked notNil)
		ifTrue: [ ^ self state checked ].
	
	^ self state normal.! !

!GLMPagerButtonImageModel methodsFor: 'states' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected: isSelected
	^ self pressed: false selected: isSelected! !

!GLMPagerButtonImageModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
state
	^ state! !

!GLMPagerButtonImageModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
state: anImageState
	state := anImageState.! !

Object subclass: #GLMPagerButtonImageState
	instanceVariableNames: 'normalImage pressedImage selectedImage checkedImage announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonImageState methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checked
	^ checkedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checked: anImage
	checkedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checkedColor: aColor
	self checked: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/4/2014 10:44'!
checkedFromFile: aString
	self checked: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
imageFromColor: aColor
	^ Morph new color: aColor; imageForm! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
imageFromFile: aString
	^ ImageReadWriter formFromFileNamed: aString.! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal
	^ normalImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normal: anImage
	normalImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normalColor: aColor
	self normal: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
normalFromFile: aString
	self normal: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed
	^ pressedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressed: anImage
	pressedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressedColor: aColor
	self pressed: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
pressedFromFile: aString
	self pressed: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'getters' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected
	^ selectedImage! !

!GLMPagerButtonImageState methodsFor: 'setters-image' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selected: anImage
	selectedImage := anImage.
	self stateUpdated.! !

!GLMPagerButtonImageState methodsFor: 'setters-color' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selectedColor: aColor
	self selected: (self imageFromColor: aColor)! !

!GLMPagerButtonImageState methodsFor: 'setters-file' stamp: 'AliakseiSyrel 4/2/2014 16:43'!
selectedFromFile: aString
	self selected: (self imageFromFile: aString)! !

!GLMPagerButtonImageState methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
stateUpdated
	self announcer announce: GLMPagerButtonImageUpdated new.! !

Object subclass: #GLMPagerButtonModel
	instanceVariableNames: 'announcer isSelected isPressed isChecked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
check
	self isChecked ifFalse: [
		isChecked := true.
		self announcer announce: (GLMPagerButtonChecked new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
click
	self announcer announce: (GLMPagerButtonClicked new buttonModel: self).! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
depress
	self isPressed ifTrue: [ 
		isPressed := false.
		self announcer announce: (GLMPagerButtonDepressed new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:34'!
deselect
	self isSelected ifTrue: [
		isSelected := false.
		self announcer announce: (GLMPagerButtonDeselected new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 10:45'!
initialize
	super initialize.
	
	isSelected := false.
	isPressed := false.
	isChecked := false.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 10:45'!
isChecked
	^ isChecked.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
isPressed
	^ isPressed.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/2/2014 16:42'!
isSelected
	^ isSelected.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/4/2014 11:17'!
on: anObject send: aSymbol to: aReceiver
	self announcer weak
		on: anObject send: aSymbol to: aReceiver.! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
press
	self isPressed ifFalse: [
		isPressed := true.
		self announcer announce: (GLMPagerButtonPressed new).
		self click.
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:34'!
select
	self isSelected ifFalse: [ 
		isSelected := true.
		self announcer announce: (GTPagerButtonSelected new).
	]! !

!GLMPagerButtonModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
uncheck
	self isChecked ifTrue: [
		isChecked := false.
		self announcer announce: (GLMPagerButtonChecked new).
	]! !

GLMPagerButtonModel subclass: #GLMPagerCircleButtonModel
	instanceVariableNames: 'pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerCircleButtonModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:22'!
pageIndex
	^ pageIndex! !

!GLMPagerCircleButtonModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 11:22'!
pageIndex: anObject
	pageIndex := anObject! !

Object subclass: #GLMPagerModel
	instanceVariableNames: 'numberOfVisiblePages announcer firstVisiblePageIndex pagesCount lastVisiblePageIndex focusedPageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 20:30'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 14:27'!
circleButtonInset
	^ 6! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/15/2014 18:26'!
circleButtonSize
	^ 16! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:58'!
defaultFirstVisiblePageIndex
	^ 1! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:18'!
defaultNumberOfVisiblePages
	^ 2! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 10:36'!
firstVisiblePageIndex
	^ firstVisiblePageIndex! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:19'!
firstVisiblePageIndex: aNumber
	aNumber < 1 ifTrue: [ 
		firstVisiblePageIndex := 1.
		^ self ].
	aNumber > self pagesCount ifTrue: [ 
		firstVisiblePageIndex := self pagesCount.
		^ self].
	firstVisiblePageIndex := aNumber.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:50'!
focusedPageIndex
	^ focusedPageIndex! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 18:52'!
focusedPageIndex: anIndex

	(self focusedPageIndex = anIndex) not ifTrue:[
		focusedPageIndex := anIndex.
		self notifyFocusedPageChanged.
	].
	! !

!GLMPagerModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 4/19/2014 19:00'!
initialize
	super initialize.

	pagesCount := 0.
	focusedPageIndex := 1.
	self numberOfVisiblePages: self defaultNumberOfVisiblePages.
	
	firstVisiblePageIndex:= self defaultFirstVisiblePageIndex.
	lastVisiblePageIndex:= firstVisiblePageIndex.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:21'!
lastVisiblePageIndex
	| lastIndex |
	
	lastIndex := self firstVisiblePageIndex + self numberOfVisiblePages - 1.
	^ lastIndex > self pagesCount
		ifTrue: [ self pagesCount ]
		ifFalse: [ lastIndex ]! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:22'!
lastVisiblePageIndex: aNumber
	aNumber < 1 ifTrue: [ aNumber := 1 ].
	aNumber > self pagesCount ifTrue: [ aNumber := self pagesCount ].
	lastVisiblePageIndex := aNumber.
	
	lastVisiblePageIndex < firstVisiblePageIndex ifTrue: [
		lastVisiblePageIndex := firstVisiblePageIndex ]! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:52'!
notifyFocusedPageChanged

	self announcer announce: GLMFocusedPageChanged new.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/15/2014 22:45'!
notifyNumberOfVisiblePagesChanged

	self announcer announce: GLMNumberOfVisiblePagesChanged new.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/15/2014 22:45'!
notifyPagePoped

	self announcer announce: GLMPagePoped new.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/15/2014 22:45'!
notifyPagePushed: aMorph scrollTo: aBoolean smooth: isSmooth
	
	self announcer announce: (GLMPagePushed new morph: aMorph).
	
	aBoolean ifTrue: [self scrollToRight: isSmooth ]! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/15/2014 22:46'!
notifyPageSwitched: isSmooth
	self announcer announce: (GLMPageSwitched new smooth: isSmooth).! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/16/2014 07:33'!
notifyScrollerBoundsChanged: aBounds
	self announcer announce: (GLMPagerBoundsChanged new bounds: aBounds).! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 10:37'!
numberOfVisiblePages
	^ numberOfVisiblePages! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 20:26'!
numberOfVisiblePages: aNumber
	numberOfVisiblePages := aNumber.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/6/2014 13:40'!
numberOfVisiblePagesChanged
	|currentNumberOfVisiblePages|
	
	currentNumberOfVisiblePages := lastVisiblePageIndex - self firstVisiblePageIndex + 1.
	
	self numberOfVisiblePages = currentNumberOfVisiblePages ifFalse: [
		self numberOfVisiblePages: 	currentNumberOfVisiblePages.
		self notifyNumberOfVisiblePagesChanged.
	]! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:28'!
pagesCount
	^ pagesCount! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 4/5/2014 17:47'!
popAndReplacePane: aMorph
	self popPane.
	self pushPane: aMorph smooth: false.
	self notifyPageSwitched: false.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 4/6/2014 14:44'!
popPane
	pagesCount >= 1 ifTrue: [
		|scrollTo|
		pagesCount := pagesCount - 1.
		scrollTo := ((pagesCount = self firstVisiblePageIndex) & (pagesCount > self numberOfVisiblePages)).
		self notifyPagePoped.
		false ifTrue: [ self scrollToRight: true ].
	]! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 4/6/2014 14:44'!
pushPane: aMorph smooth: aBoolean

	pagesCount := pagesCount + 1.	
	self notifyPagePushed: aMorph scrollTo: true smooth: aBoolean.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'TudorGirba 4/16/2014 07:35'!
scrollTo: aFloat smooth: aBoolean
	self announcer announce: (GLMPagerScrolled new value: aFloat; smooth: aBoolean).! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 17:00'!
scrollToRight: isSmooth
	self scrollTo: 1.0 smooth: isSmooth! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 4/6/2014 14:16'!
switchPageTo: aNumber

	aNumber + self numberOfVisiblePages - 1 > self pagesCount
		ifTrue: [ aNumber :=  self pagesCount - self numberOfVisiblePages + 1].
		
	self firstVisiblePageIndex: aNumber.
	self notifyPageSwitched: true.! !

GLMMorphicFinderRenderer subclass: #GLMMorphicPagerFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMMorphicPagerFinderRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:49'!
actOnPaneAdded: ann
	container pushPane: (self renderObject: ann pane).! !

!GLMMorphicPagerFinderRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:50'!
actOnPaneRemoved: ann
	container popPane! !

!GLMMorphicPagerFinderRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/5/2014 13:54'!
actOnPaneReplaced: ann
	container popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicPagerFinderRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 4/19/2014 17:46'!
render: aBrowser
	container := GLMPagerMorph new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		adapter: GLMPagerModel new;
		beTransparent;
		yourself.
	"container maxPanes: aBrowser fixedSizePanes."
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !
